/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CUSTOMIZETOOLBAR_H
#define CUSTOMIZETOOLBAR_H

#include "settings.h"

#include <gtkmm/accelgroup.h>
#include <gtkmm/button.h>
#include <gtkmm/buttonbox.h>
#include <gtkmm/treeview.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/box.h>
#include <gtkmm/dialog.h>
#include <gtkmm/main.h>
#include <glib.h>

// Class to add column to a TreeView (TreeModel)
class ModelColumnsToolbar : public Gtk::TreeModel::ColumnRecord
{
public:
  ModelColumnsToolbar()  { add(col_icon); add(col_text); }
  Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > col_icon;
  Gtk::TreeModelColumn<Glib::ustring> col_text;
};

// Toolbar Customization dialog class
class customize_toolbar : public Gtk::Dialog
{  
public:
  customize_toolbar(environment_settings&, Glib::RefPtr<Gtk::ActionGroup>);
  ~customize_toolbar();

  void initialize_objects();
  void populate_available_treeview();
  void populate_used_treeview();
  void set_icon_array(Glib::RefPtr<Gtk::ActionGroup>);

  void on_add();
  void on_delete();
  void on_move_up();
  void on_move_down();

  Glib::ustring get_toolbar();

private:
  Gtk::Dialog *dialog;
  Gtk::Button *cancel, *apply, *add, *remove, *up, *down;
  Gtk::TreeView *available, *used;
  Gtk::ScrolledWindow *swin1, *swin2;
  Gtk::HBox *hbox;
  Gtk::VBox *vbox;
  Glib::ustring toolbar;
  int max_elements;
};

#endif
