/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ENVIRONMENT_H
#define ENVIRONMENT_H

#include "settings.h"

#include <gtkmm/dialog.h>
#include <gtkmm/button.h>
#include <gtkmm/buttonbox.h>
#include <gtkmm/entry.h>
#include <gtkmm/spinbutton.h>
#include <gtkmm/label.h>
#include <gtkmm/checkbutton.h>
#include <gtkmm/fixed.h>
#include <gtkmm/box.h>
#include <gtkmm/notebook.h>
#include <glib.h>

// Environment Dialog class
class environment_dialog : public Gtk::Dialog
{
public:
  environment_dialog (environment_settings&);
  ~environment_dialog();

  void initialize_objects();
  
  int get_asave_minutes();
  int get_tab_size();
  bool get_load_on_launch();
  bool get_replace_tabs();
  Glib::ustring get_font_size();
  Glib::ustring get_terminal();
  Glib::ustring get_font_face();
  Glib::ustring get_error_color();
  Glib::ustring get_warning_color();
  Glib::ustring get_variables();
  Glib::ustring get_characters();
  Glib::ustring get_strings();
  Glib::ustring get_comments();
  Glib::ustring get_keywords();
  Glib::ustring get_preprocessor();

private:
  Gtk::Dialog *dialog;
  Gtk::Notebook *notebook;
  Gtk::Button *cancel, *ok, *button_color1, *button_color2, *button_color3, *button_color4,
              *button_color5, *button_color6, *button_color7, *button_color8;
  Gtk::Label *label_tabstops, *label_tabwidth, *label_terminal, *label_use_terminal, 
             *label_filemanagement, *label_autosave, *label_minutes, *label_editor,
             *label_font, *label_editor_font, *label_compiler, *label_error, *label_fonts,
             *label_elements, *label_vars, *label_warning, *label_chars, *label_strn, 
             *label_cmnt, *label_kywd, *label_prep, *label_syntax;
  Gtk::Adjustment *tab_size_adj, *asave_minutes_adj;
  Gtk::SpinButton *tab_size, *asave_minutes;
  Gtk::CheckButton *replace_tabs, *load_on_launch;
  Gtk::HBox *hbox, *hbox2, *hbox3, *hbox4, *hbox5, *hbox6, *hbox7,
            *hbox8, *hbox9, *hbox10, *hbox11, *hbox12;
  Gtk::VBox *vbox, *vbox2, *vbox3;
  Gtk::Fixed *fixed, *fixed2;
  Gtk::Entry *terminal, *error_color, *warning_color, *variables, *characters,
             *strings, *comments, *keywords, *preprocessor;
  Gtk::Image *image1, *image2, *image3, *image4, *image5, *image6, *image7, *image8;
  Gtk::FontButton *fontbutton;
  Glib::ustring fontname;
};

#endif
