/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "gotoline.h"

void openldev::populate_goto_line_toolbar()
{
  button_close_goto = new Gtk::Button();
  label_goto_line = new Gtk::Label("Goto Line: ");
  button_goto_line = new Gtk::Button(Gtk::StockID("gtk-jump-to"));
  image_error2 = new Gtk::Image(Gtk::StockID("gtk-dialog-error"), Gtk::IconSize(1));
  image_close2 = new Gtk::Image(Gtk::StockID("gtk-stop"), Gtk::IconSize(1));
  label_error2 = new Gtk::Label("Line out of bounds!");
  Gtk::Adjustment *spinbutton_adj = new Gtk::Adjustment(1, 1, 99999, 1, 10, 10);
  goto_line = new Gtk::SpinButton(*spinbutton_adj, 1, 0);
  hbox_goto = new Gtk::HBox(false, 0);

  button_close_goto->set_relief(Gtk::RELIEF_NONE);
	button_close_goto->add(*image_close2);
  button_goto_line->set_relief(Gtk::RELIEF_NONE);
  
  hbox_goto->set_spacing(5);
  hbox_goto->set_border_width(3);
  hbox_goto->pack_start(*button_close_goto, Gtk::PACK_SHRINK);
  hbox_goto->pack_start(*label_goto_line, Gtk::PACK_SHRINK);
  hbox_goto->pack_start(*goto_line, Gtk::PACK_SHRINK);
  hbox_goto->pack_start(*button_goto_line, Gtk::PACK_SHRINK);
  hbox_goto->pack_start(*image_error2, Gtk::PACK_SHRINK);
  hbox_goto->pack_start(*label_error2, Gtk::PACK_SHRINK);

  button_close_goto->signal_clicked().connect(sigc::mem_fun(*this, &openldev::on_edit_goto_line));
  button_goto_line->signal_clicked().connect(sigc::mem_fun(*this, &openldev::jump_to_line_number));
}

// Goto Line number in TextView
void openldev::on_edit_goto_line() 
{
  if (hbox_goto->is_visible())
    hbox_goto->hide();
  else
  {
    hbox_goto->show();
    if (hbox_find->is_visible())
      on_edit_find();
  }
}

void openldev::jump_to_line_number()
{
  Glib::RefPtr<Gtk::TextBuffer> buffer = noteman->get_current_textview()->get_buffer();
  
  if (buffer->get_line_count() >= goto_line->get_value_as_int())
  {
    Gtk::TextIter iter = buffer->get_iter_at_line(goto_line->get_value_as_int()-1);
    buffer->move_mark(buffer->get_insert(), iter);
    buffer->move_mark(buffer->get_selection_bound(), iter);
    noteman->scroll_to_mark();
    set_focus(*noteman->get_current_textview());
    
    label_error2->hide();
    image_error2->hide();
  }
  else
  {
    label_error2->show();
    image_error2->show();
  }
}
