/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef NEW_FILE_H
#define NEW_FILE_H

#include "project.h"

#include <gtkmm/dialog.h>
#include <gtkmm/button.h>
#include <gtkmm/label.h>
#include <gtkmm/separator.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/entry.h>
#include <gtkmm/box.h>
#include <gtkmm/table.h>
#include <gtkmm/combo.h>
#include <iostream>
#include <glib.h>
using namespace std;

// New file/project class
class new_file_dialog : public Gtk::Dialog
{
public:
  new_file_dialog (project_settings);
  ~new_file_dialog();

  void initialize_objects();
  void populate_combobox();
  void on_apply();
  void on_cancel();
  bool key_pressed_name(GdkEventKey*);
  Glib::ustring get_filename();

private:
  Gtk::Dialog *dialog;
  Gtk::Button *cancel, *apply;
  Gtk::Label *label1, *label2;
  Gtk::Entry *name;
  Gtk::HBox *hbox, *hbox2;
  Gtk::VBox *vbox, *vbox2, *vbox3;
  Gtk::Combo *combobox;
  Gtk::HSeparator *hseparator;
  Glib::ustring file_location;
};

#endif
