/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef NOTEBOOKMANAGER_H
#define NOTEBOOKMANAGER_H

#include "settings.h"
#include "notebooktab.h"

#include <iostream>
using namespace std;

// Notebook manager class that handles the tabs
class notebook_manager
{
public:
	notebook_manager();
	~notebook_manager();

	Gtk::Notebook* get_notebook();
	bool add_tab(Glib::ustring, environment_settings);
	void delete_tab(Glib::ustring);
  void erase_all_tabs();
  void save_all_files();
  void scroll_to_mark();
  Gtk::TextView* get_current_textview();
  int get_current_tab();
  void mark_current_tab_modified(bool);
  action_manager& get_aman();
  void modify_fonts(Pango::FontDescription);
  Glib::ustring get_current_filename();
  Glib::ustring get_current_short_filename();
  void update_line_numbers();
  void create_line_numbers();
  void show_line_numbers(bool);
  void sync_scrollbars();
	
private:
	int tab_count;
	deque<notebook_tab> tabs;
	Gtk::Notebook* notebook;
};

#endif
