/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef PROJECT_H
#define PROJECT_H

#include <iostream>
#include <gtkmm.h>
#include <glib.h>
using namespace std;

// Project properties class
class project_settings
{
public:
  project_settings();
  ~project_settings();

  bool load_project_file(Glib::ustring);
  void write_project_file();
  void write_source_makefile();

  Glib::ustring get_name();
  Glib::ustring get_author();
  Glib::ustring get_email();
  Glib::ustring get_url();
  Glib::ustring get_version();
  Glib::ustring get_source_files();
  Glib::ustring get_header_files();
  Glib::ustring get_other_files();
  Glib::ustring get_lastfile();
  Glib::ustring get_location();
  char get_language();
  
  void set_source_files(Glib::ustring);
  void set_header_files(Glib::ustring);
  void set_other_files(Glib::ustring);
  void set_lastfile(Glib::ustring);
  void set_name(Glib::ustring);
  void set_author(Glib::ustring);
  void set_email(Glib::ustring);
  void set_homepage(Glib::ustring);
  void set_version(Glib::ustring);
  void close_project();
  void add_file(Glib::ustring);
  void remove_file(Glib::ustring);

private:
  Glib::ustring name, author, email, url, version, location, 
                lastfile, sources, headers, other_files;
  char language;
};

#endif
