/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef PROJECT_INFO_H
#define PROJECT_INFO_H

#include "project.h"
#include <gtkmm/dialog.h>
#include <gtkmm/button.h>
#include <gtkmm/buttonbox.h>
#include <gtkmm/label.h>
#include <gtkmm/table.h>
#include <gtkmm/box.h>
#include <glib.h>

class project_info : public Gtk::Dialog
{
public:
  project_info(project_settings);
  ~project_info();

  void initialize_objects(project_settings);

  Glib::ustring get_number_of_files(Glib::ustring);
  Glib::ustring get_lines_of_code(Glib::ustring, Glib::ustring);

private:
  Gtk::Label *label_lines, *label_files, *label_name, *label_version, *label_lang,
             *lines, *files, *name, *version, *language;
  Gtk::HBox *hbox;
  Gtk::VBox *vbox, *vbox2;
  Gtk::Button *close;
  Gtk::Dialog *dialog;
  Gtk::Table *table;
};

#endif
