/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SCROLLEDWIN_H
#define SCROLLEDWIN_H

#include <gtkmm/scrolledwindow.h>

class ScrolledWin : public Gtk::ScrolledWindow
{
public:
  ScrolledWin(bool h = true, bool v = true)
    : ScrolledWindow(), horizontal(h), vertical(v)
  {
    set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_NEVER);
    set_shadow_type(Gtk::SHADOW_NONE);
  }
  
  virtual void on_size_request (Gtk::Requisition* req)
  {
    ScrolledWindow::on_size_request(req);
  
    if (horizontal)
      req->width = 50;
    if (vertical)
      req->height = textview_height;
  }
  
  void set_textview_height (int);

private:
  bool horizontal, vertical;
  int textview_height;
};

#endif
