/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "view.h"

// Show or hide the toolbar
void openldev::on_view_toolbar() 
{
  if (screen.get_toolbar()) 
  {
    toolbar->hide();
    screen.set_toolbar(false);
  } 
  else 
  {
    toolbar->show();
    screen.set_toolbar(true);
  }  
}

// Show or hide the status bar
void openldev::on_view_statusbar() 
{
  if (screen.get_statusbar()) 
  {
    status_bar->hide();
    status_bar2->hide();
    hbox->hide();
    screen.set_statusbar(false);
  } 
  else 
  {
    status_bar->show();
    status_bar2->show();
    hbox->show();
    screen.set_statusbar(true);
  }  
}

// Show or hide the fileviewer
void openldev::on_view_fileviewer() 
{
  if (screen.get_fileviewer()) 
  {
    scrolled_win->hide();
    tree_view->hide();
    screen.set_fileviewer(false);
  } 
  else 
  {
    scrolled_win->show();
    tree_view->show();
    screen.set_fileviewer(true);
  }  
}

// Show or hide the build output box
void openldev::on_view_buildbox() 
{
  if (screen.get_buildbox()) 
  {
    scrolled_win2->hide();
    build_box->hide();
    screen.set_buildbox(false);
  } 
  else 
  {
    scrolled_win2->show();
    build_box->show();
    screen.set_buildbox(true);
  }  
}

// Show or hide the line numbering
void openldev::on_view_lnumbers()
{
  if (env.get_line_numbers()) 
  {
    noteman->show_line_numbers(false);
    env.set_line_numbers(false);
  } 
  else 
  {
    noteman->show_line_numbers(true);
    env.set_line_numbers(true);
  }
  env.write_settings_file();
}
